#include <msp430x14x.h>
//===========================DS18B20˿========================================
#define  OUT_DS18B20_0     P6OUT &=~BIT7          //0
#define  OUT_DS18B20_1     P6OUT |= BIT7          //1
#define  DS18B20_IN        P6DIR &=~BIT7          //Ϊ
#define  DS18B20_OUT       P6DIR |= BIT7          //Ϊ
//==============================================================================
#define  RF24L01_CE_0        P3OUT &=~BIT1         
#define  RF24L01_CE_1        P3OUT |= BIT1        
//=============================RF24L01_CSN˿==================================
#define  RF24L01_CSN_0       P3OUT &=~BIT3         
#define  RF24L01_CSN_1       P3OUT |= BIT3     
//=============================RF24L01_SCK======================================
#define  RF24L01_SCK_0       P3OUT &=~BIT2      
#define  RF24L01_SCK_1       P3OUT |= BIT2   
//=============================MISO˿=========================================
#define  RF24L01_MISO_0      P3OUT &=~BIT0
#define  RF24L01_MISO_1      P3OUT |= BIT0
//============================= RF24L01_MOSI˿================================
#define  RF24L01_MOSI_0      P2OUT &=~BIT6
#define  RF24L01_MOSI_1      P2OUT |= BIT6
//==========================IRQ״̬============================================
#define  RF24L01_IRQ_0       P2OUT &=~BIT7       
#define  RF24L01_IRQ_1       P2OUT |= BIT7
//==============================================================================
#define  LED1_0              P6OUT &=~BIT1          //0
#define  LED1_1              P6OUT |= BIT1          //1
#define  LED2_0              P6OUT &=~BIT2          //0
#define  LED2_1              P6OUT |= BIT2          //1
//============================DS18B20Ĵָ=================================
#define DS18B20_READ_ROM          0x33
#define DS18B20_MATCH_ROM         0X55
#define DS18B20_SKIP_ROM          0XCC
#define DS18B20_SEARCH_ROM        0XF0
#define DS18B20_ALARM_SEARCH_ROM  0XEC
#define DS18B20_WRITE_RAM         0X40
#define DS18B20_READ_RAM          0XBE
#define DS18B20_COPY_RAM          0X48 
#define DS18B20_CONVERT_TEM       0X44
#define DS18B20_EECALL_EEPROM     0XB8
#define DS18B20_READ_POWER_SUPPLY 0XB4
//==========================NRF24L01============================================
#define TX_ADR_WIDTH    5   	// 5 uints TX address width
#define RX_ADR_WIDTH    5   	// 5 uints RX address width
#define TX_PLOAD_WIDTH  32  	// 32 TX payload
#define RX_PLOAD_WIDTH  32  	// 32 uints TX payload
//=========================NRF24L01Ĵָ===================================
#define READ_REG        0x00  	// Ĵָ
#define WRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61  	// ȡָ
#define WR_TX_PLOAD     0xA0  	// дָ
#define FLUSH_TX        0xE1 	// ϴ FIFOָ
#define FLUSH_RX        0xE2  	// ϴ FIFOָ
#define REUSE_TX_PL     0xE3  	// ظװָ
#define NOP1            0xFF  	// 
//========================SPI(nRF24L01)Ĵַ===============================
#define CONFIG          0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define STATUS          0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ0ݳ
#define RX_PW_P2        0x13  // Ƶ0ݳ
#define RX_PW_P3        0x14  // Ƶ0ݳ
#define RX_PW_P4        0x15  // Ƶ0ݳ
#define RX_PW_P5        0x16  // Ƶ0ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ
//=============================RF24l01״̬=====================================
char  TX_ADDRESS[TX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//صַ
char  RX_ADDRESS[RX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//յַ
char  sta;
//===========================DS18B20ر====================================
char temp_data[2]={0x00,0x00};
char dispaly[32];
//******************************************************************************
//ϵͳʼ
//******************************************************************************
void InitSys()
{
   unsigned int iq0;
   _DINT();
   BCSCTL1 &=~XT2OFF;
   do
   {
      IFG1 &= ~OFIFG;							// ʧЧ־
      for (iq0 = 0xFF; iq0 > 0; iq0--);	// ʱȴXT2
   }
   while ((IFG1 & OFIFG) != 0);		// жXT2Ƿ		
   BCSCTL2 =SELM1+SELS;                // MCLK,SMCLKʱΪXT2		
}
//===========================LED˿==========================================
void LED_IO_set(void)
{    
      P6DIR |= 0x06;   P6SEL&=0xf9;        
}
//==============================================================================
void DS18B20_IO_set(void)
{
  P6SEL&=0x7f; 
}
//===========================RF24L01˿==========================================
void RF24L01_IO_set(void)
{
      P2DIR &= 0x7f;    P2DIR |= 0x40;  P2SEL&=0x3F;   P2IE=P2IE&0x3f;
      P3DIR &= 0xFE;    P3DIR |= 0x0E;  P3SEL&=0xF0;
}
//========================ʱԼ5ms=============================================
void ms_delay(void)
{ 
   unsigned int i=40000;
    while (i != 0)
    {
        i--;
    }
}
//========================================ʱ================================
void Delay(int s)
{
	unsigned int i,j;
	for(i=0; i<s; i++);
	for(j=0; j<s; j++);
}
//===========================DS18B20ʱ========================================  
void DS1820_delay(int i)
{
	while(i--);
}
//==========================DS18B20λ=========================================
void ds18b20_reset(void) 
{ 

  DS18B20_OUT; //
  OUT_DS18B20_1;
  OUT_DS18B20_0;
  DS1820_delay(3000);  //500us
  OUT_DS18B20_1;
  DS18B20_IN;    //Ϊ
  DS1820_delay(40);
  while(P6IN&BIT7);
  DS18B20_OUT;
  OUT_DS18B20_1;
  DS1820_delay(300);
} 
//========================DS18B20=====================================
char ds18b20_read(void) 
{ 
  char i;
  char temp=0;
  for(i=0;i<8;i++)
  {
   DS18B20_OUT;
   OUT_DS18B20_0;
   temp>>=1;
   OUT_DS18B20_1;
   DS18B20_IN;
   if(P6IN&BIT7)
   {
     temp|=0x80;
   }
     DS1820_delay(4);
     DS18B20_OUT;
     DS1820_delay(50);
  }
return (temp);
}
//========================DS18B20д=====================================
void ds18b20_write(char Date) 
{ 
  char i; 
    DS18B20_OUT;
     for(i=0;i<8;i++)
     {
       OUT_DS18B20_0;
      // DS1820_delay(6);
       if(Date & 0x01) 
       {
         OUT_DS18B20_1;
       }
       else
       {
         OUT_DS18B20_0;
       }
       DS1820_delay(40);
       OUT_DS18B20_1;
       Date>>=1;
     }
       DS1820_delay(8);
} 

//======================DS18B20¶ת=====================================
void Ds18b20Convert(void) 
{ 
   ds18b20_reset(); 
  ds18b20_write(0xCC); 
  ds18b20_write(0x44);
  
  Delay(200);
    
  ds18b20_reset(); 
  ds18b20_write(0xCC); //??????
  ds18b20_write(0xBE); //?RAM??
  
  temp_data[0]=ds18b20_read(); 
  temp_data[1]=ds18b20_read();
}
//=========================¶Ȼ㴦=========================================
void work_temp()
{
	char n=0;
if(temp_data[1]>127)
	{
	temp_data[1]=(256-temp_data[1]);			//ֵ
	temp_data[0]=(256-temp_data[0]);
	n=1;
	}
	dispaly[6]=((temp_data[0]&0xf0)>>4)|((temp_data[1]&0x0f)<<4);
	dispaly[5]=dispaly[6]/100;				//λ
	dispaly[4]=dispaly[6]%100;				//
	dispaly[2]=dispaly[4]/10;				//ʮλ
	dispaly[1]=dispaly[4]%10;				//λ	
	switch	(temp_data[0]&0x0f)				//Сλ
	{
	case 0x0f:dispaly[0]=9;break;
	case 0x0e:dispaly[0]=9;break;
	case 0x0d:dispaly[0]=8;break;
	case 0x0c:dispaly[0]=8;break;
	case 0x0b:dispaly[0]=7;break;
	case 0x0a:dispaly[0]=6;break;
	case 0x09:dispaly[0]=6;break;
	case 0x08:dispaly[0]=5;break;
	case 0x07:dispaly[0]=4;break;
	case 0x06:dispaly[0]=4;break;
	case 0x05:dispaly[0]=3;break;
	case 0x04:dispaly[0]=3;break;
	case 0x03:dispaly[0]=2;break;
	case 0x02:dispaly[0]=1;break;
	case 0x01:dispaly[0]=1;break;
	case 0x00:dispaly[0]=1;break;
	default:break;
	}
if(n)										//ֵʱʾaa,ֱʾdd
	{
	dispaly[3]=0x11;						//
	}
else 	dispaly[3]=0x22;
}
//******************************************************************************************
//ʱ
//******************************************************************************************
void inerDelay_us(char n)
{
	for(;n>0;n--);
}
//==============================================================================
//uint SPI_RW(uint uchar)
//ܣNRF24L01SPIдʱ
//******************************************************************************
char SPI_RW(char data)
{
	char i,temp=0;
   	for(i=0;i<8;i++) // output 8-bit
   	{
	if((data & 0x80)==0x80)
	{
		RF24L01_MOSI_1;         // output 'uchar', MSB to MOSI
	}
	else
	{
	 	RF24L01_MOSI_0; 
	}	
//==============================================================================
		data = (data << 1);            // shift next bit into MSB..
		temp<<=1;
		RF24L01_SCK_1;                // Set SCK high..
		if((P3IN&0x01)==0x01)temp++;         // capture current MISO bit
		RF24L01_SCK_0;              // ..then set SCK low again
   	}
    return(temp);           		  // return read uchar
}
//****************************************************************************************************
//uchar SPI_Read(uchar reg)
//ܣNRF24L01SPIʱ
//****************************************************************************************************
char SPI_Read(char reg)
{
	char reg_val;
	RF24L01_CSN_0;           // CSN low, initialize SPI communication...
	SPI_RW(reg);            // Select register to read from..
	reg_val = SPI_RW(0);    // ..then read registervalue
	RF24L01_CSN_1;         // CSN high, terminate SPI communication
	return(reg_val);       // return register value
}
//****************************************************************************************************/
//ܣNRF24L01дĴ
//****************************************************************************************************/
char SPI_RW_Reg(char reg, char value)
{
	char status1;
	RF24L01_CSN_0;                   // CSN low, init SPI transaction
	status1 = SPI_RW(reg);      // select register
	SPI_RW(value);             // ..and write value to it..
	RF24L01_CSN_1;                   // CSN high again
	return(status1);            // return nRF24L01 status uchar
}
//****************************************************************************************************/
//uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars)
//: ڶݣregΪĴַpBufΪݵַucharsݵĸ
//****************************************************************************************************/
char SPI_Read_Buf(char reg, char *pBuf, char chars)
{
	char status2,uchar_ctr;
	RF24L01_CSN_0;                    		// Set CSN low, init SPI tranaction
	status2 = SPI_RW(reg);       		// Select register to write to and read status uchar
	for(uchar_ctr=0;uchar_ctr<chars;uchar_ctr++)
        {
	pBuf[uchar_ctr] = SPI_RW(0);    // 
        }
	RF24L01_CSN_1;                           
	return(status2);                    // return nRF24L01 status uchar
}
//*********************************************************************************************************
//uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar uchars)
//: дݣΪĴַpBufΪдݵַucharsдݵĸ
//*********************************************************************************************************/
char SPI_Write_Buf(char reg, char *pBuf, char chars)
{
	char status1,uchar_ctr;
	RF24L01_CSN_0;             //SPIʹ       
	status1 = SPI_RW(reg);   
	for(uchar_ctr=0; uchar_ctr<chars; uchar_ctr++) //
        {
	SPI_RW(*pBuf++);
        }
	RF24L01_CSN_1;           //رSPI
	return(status1);    		  // 
}
//****************************************************************************************************/
//void SetRX_Mode(void)
//ܣݽ 
//****************************************************************************************************/
void SetRX_Mode(void)
{
	RF24L01_CE_0 ;
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);   		// IRQշжӦ16λCRC	
	RF24L01_CE_1; 
	inerDelay_us(130);//עⲻ̫С
}
//******************************************************************************************************/
//unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
//ܣݶȡrx_bufջ
//******************************************************************************************************/
char nRF24L01_RxPacket(char* rx_buf)
{
    char revale=0;
	sta=SPI_Read(STATUS);	     // ȡ״̬Ĵжݽ״		
	if(sta&0x40)                 // жǷյ
	{
	    RF24L01_CE_0 ; 			//SPIʹ
	    SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
	    revale =1;			//ȡɱ־
	}
	SPI_RW_Reg(WRITE_REG+STATUS,sta);   //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
	return revale;
}
//***********************************************************************************************************
//void nRF24L01_TxPacket(char * tx_buf)
//ܣ tx_buf
//**********************************************************************************************************/
void nRF24L01_TxPacket(char * tx_buf)
{
	RF24L01_CE_0 ;			//StandBy Iģʽ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // װؽն˵ַ
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			 // װ	
   //     SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);   		 // IRQշжӦ16λCRC
	RF24L01_CE_1;		 //øCEݷ
	inerDelay_us(10);
}
//****************************************************************************************
//NRF24L01ʼ
//***************************************************************************************/
void init_NRF24L01(void)
{
        inerDelay_us(100);
 	RF24L01_CE_0 ;    // chip enable
 	RF24L01_CSN_1;   // Spi disable 
 	RF24L01_SCK_0;   // Spi clock line init high
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      //  Ƶ0Զ	ACKӦ	
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  //  յַֻƵ0ҪƵԲοPage21  
	SPI_RW_Reg(WRITE_REG + RF_CH, 0);        //   ŵΪ2.4GHZշһ
	SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);   //÷Ϊ1MHZ书Ϊֵ0dB
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0E);   // IRQշжӦ16λCRC	}
} 
//=============================================================================
main()
{     
      WDTCTL = WDTPW + WDTHOLD; //ֹŹ
      LED_IO_set();
      RF24L01_IO_set();
      DS18B20_IO_set(); 
      InitSys();
      init_NRF24L01() ;
      Ds18b20Convert();
      LED1_1;LED2_1;
      while(1)
      {
       Ds18b20Convert();          //ɼ¶
       LED1_0;
       work_temp();	
       nRF24L01_TxPacket(dispaly);  //Ѳɼõ¶ݷͳȥ	
       SPI_RW_Reg(WRITE_REG+STATUS,0XFF);   //״̬Ĵ
       ms_delay();          
       ms_delay();
       LED1_1;
       ms_delay();          
       ms_delay();
      }
}